<?php
class appFacebookListener
{
   public static function append(sfEvent $event, $components)
   {
      $config = stConfig::getInstance(sfContext::getInstance(), 'appFacebookBackend');

 

      switch($event['slot'])
      {
         case 'product_label_footer':
         case 'product-label-footer':
         $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showInProduct');
         break;
      }
      
      switch($event['slot'])
      {
         case 'before_head_ends':
         case 'before-head-ends':
         $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showMetaTags');                          
         break;
      }
        
      

      if ($config->get('comments_position') == "before"  && $config->get('comments_facebook_on') == "1")
      {
         switch($event['slot'])
         {
            case 'before_reviews':
            case 'before-reviews':
            $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showComments');
            break;
         }
      }

      if ($config->get('comments_position') == "after" && $config->get('comments_facebook_on') == "1")
      {
         switch($event['slot'])
         {
            case 'after_reviews':
            case 'after-reviews':
            $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showComments');
            break;
         }
      }
      
      

      if ($config->get('login_facebook_on') == "1")
      {

         switch($event['slot'])
         {
            case 'login_google_user':
            case 'login-google-user':
            $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showLoginUser');            
            break;    

         }

         switch($event['slot'])
         {
            case 'login_google_basket':
            case 'login-google-basket':
            $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'showLoginBasket');                    
            break;
         }

      }

      

      return $components;
   }

   public static function prepend(sfEvent $event, $components)
   {
      switch($event['slot'])
      {
         case 'base_header':
         case 'base-header':
         $components[] = $event->getSubject()->createComponent('appFacebookFrontend', 'show');                    
         break;
      }
      
      return $components;
   }

    /**
     * Podpięcie linku do recenzji produktów w panelu klienta
     *
     * @param       sfEvent     $event
     */
    public static function postExecuteShow(sfEvent $event)
    {
        sfLoader::loadHelpers('Helper');
        sfLoader::loadHelpers('stUrl');
        sfLoader::loadHelpers('stProductImage');

        $config = stConfig::getInstance(sfContext::getInstance(), 'appFacebookBackend');
        $action = $event->getSubject();

        if ($config->get('comments_facebook_on') == "1")
        {
           $config = stConfig::getInstance(sfContext::getInstance(), array(
           'product_views' => stConfig::STRING, 'price_view' => stConfig::STRING),
           'stProduct'
           );
           $config->load();

           $show_review=$config->get('show_review');

           $c = new Criteria();
           $c->add(ReviewPeer::PRODUCT_ID, $action->product->getId());
           $c->add(ReviewPeer::ACTIVE, 1);
           $criterion = $c->getNewCriterion(ReviewPeer::AGREEMENT, 1);
           $criterion->addOr($c->getNewCriterion(ReviewPeer::USER_IP, $action->getRequest()->getHttpHeader ('addr','remote')));
           $c->add($criterion);
           $c->add(ReviewPeer::DESCRIPTION, "", Criteria::NOT_IN);

           if ($show_review==1 && !ReviewPeer::doSelectOne($c))
           {
               if(sfContext::getInstance()->getController()->getTheme()->getVersion() < 7){
                    $action->productDescription->addTab('Recenzje', 'stReview', 'listReviews', array('id' => $action->product->getId()));
               }else{           
                    $action->tabNavigator->addTab('Recenzje', 'stReview', 'listReviews', array('id' => $action->product->getId()));
               }    
                   
           }

       }
       
    }

}
?>
