<?php
/**
 * SOTESHOP/appFacebookPlugin
 *
 *
 * @package     appContactPlugin
 * @author      Bartosz Alejski <whiteface@whiteface.pl>
 */
class appFacebookFrontendActions extends sfActions {
    public function executeContent() {
        $this -> smarty = new stSmarty($this -> getModuleName());

        $config = stConfig::getInstance($this -> getContext(), 'appFacebookBackend');
        $this -> facebookConfig = $config -> load();
        
        $this -> securityConfig = stConfig::getInstance($this->getContext(), 'stSecurityBackend');

        $this->user_culture = $this->facebookCulture();
    }

    public function executeFacebookSingIn() {
        
        
        // echo $_SERVER['HTTP_HOST'];
        // var_dump($_SERVER);
        // die();

        $config = stConfig::getInstance($this -> getContext(), 'appFacebookBackend');
        $facebookConfig = $config -> load();
                
        if($facebookConfig['api_version']!=2){
        //stara wersja API
            
        $facebook = new stFacebook( array('appId' => $facebookConfig['facebook_app_id'], 'secret' => $facebookConfig['facebook_app_secret'], ));

        $user = $facebook -> getUser();

        if ($user) {
            try {
                // Proceed knowing you have a logged in user who's authenticated.
                $user_profile = $facebook -> api('/me?fields=id,name,email');
            } catch (stFacebookApiException $e) {
                error_log($e);
                $user = null;
            }

            if (!empty($user_profile)) {
                $username = $user_profile['email'];
                $back = $this -> getRequestParameter('back');
                $this -> LoginFacebookUser($username, $back);
            }

        } else {
            # There's no active session, let's generate one
            $login_url = $facebook -> getLoginUrl(array('scope' => 'email'));

            $this -> redirect($login_url);

        }
        
        }else{
        // Nowa wersja API
        
        require_once SF_ROOT_DIR.'/apps/frontend/lib/facebook/autoload.php';
        $this->getUser()->setAttribute('facebook_app_id', $facebookConfig['facebook_app_id']);
        $this->getUser()->setAttribute('facebook_app_secret', $facebookConfig['facebook_app_secret']);
        
        require_once SF_ROOT_DIR.'/apps/frontend/lib/facebook/init.php';
          
          $helper = $fb->getRedirectLoginHelper();
      
          try {
              $accessToken = $helper->getAccessToken($this->siteURL().'/appFacebookFrontend/FacebookSingIn/back/'.$this -> getRequestParameter('back'));
            } catch(Facebook\Exceptions\FacebookResponseException $e) {
              // When Graph returns an error
              echo 'Graph returned an error: ' . $e->getMessage();
              exit;
            } catch(Facebook\Exceptions\FacebookSDKException $e) {
              // When validation fails or other local issues
              echo 'Facebook SDK returned an error: ' . $e->getMessage();
              exit;
            }
      
          
             try {
              // Returns a `Facebook\FacebookResponse` object
              $response = $fb->get('/me?fields=id,name,email', $accessToken);
              $user_profile = $response->getGraphUser();                                  
                    
                if (!empty($user_profile)) {
                    $username = $user_profile['email'];
                    $back = $this -> getRequestParameter('back');
                                        
                    $this -> LoginFacebookUser($username, $back);
                }
              
            } catch(Facebook\Exceptions\FacebookResponseException $e) {
              echo 'Graph returned an error: ' . $e->getMessage();
              exit;
            } catch(Facebook\Exceptions\FacebookSDKException $e) {
              echo 'Facebook SDK returned an error: ' . $e->getMessage();
              exit;
            }                
        }
    }

    public function LoginFacebookUser($username, $action) {

        if (!sfGuardUserPeer::retrieveByUsername($username)) {
            stUser::addUser($username);
            stUser::setExternalAccount($username, "facebook");
            stUser::setIsConfirm($username);
        }

        stUser::loginUserOnlyUsername($username);

        if ($action == "create") {
            $user = sfGuardUserPeer::retrieveByUsername($username);

            $c = new Criteria();
            $c -> add(UserDataPeer::SF_GUARD_USER_ID, $user -> getId());

            if (UserDataPeer::doSelectOne($c)) {
                $this -> redirect('stUserData/userPanel');
            } else {
                $this -> redirect('stUserData/createFirstUserData');
            }

        }

        if ($action == "basket") {
            $this -> redirect('stBasket/index#external_account');
        }

    }

    public function facebookCulture() {
        if ($this -> getUser() -> getCulture() == "ar") {
            $this -> user_culture = "ar_AR";
        } elseif ($this -> getUser() -> getCulture() == "bg") {
            $this -> user_culture = "bg_BG";
        } elseif ($this -> getUser() -> getCulture() == "cs") {
            $this -> user_culture = "cs_CZ";
        } elseif ($this -> getUser() -> getCulture() == "da") {
            $this -> user_culture = "da_DK";
        } elseif ($this -> getUser() -> getCulture() == "de") {
            $this -> user_culture = "de_DE";
        } elseif ($this -> getUser() -> getCulture() == "el") {
            $this -> user_culture = "el_GR";
        } elseif ($this -> getUser() -> getCulture() == "en_US") {
            $this -> user_culture = "en_US";
        } elseif ($this -> getUser() -> getCulture() == "es") {
            $this -> user_culture = "es_ES";
        } elseif ($this -> getUser() -> getCulture() == "et") {
            $this -> user_culture = "et_EE";
        } elseif ($this -> getUser() -> getCulture() == "fi") {
            $this -> user_culture = "fi_FI";
        } elseif ($this -> getUser() -> getCulture() == "fr") {
            $this -> user_culture = "fr_FR";
        } elseif ($this -> getUser() -> getCulture() == "he") {
            $this -> user_culture = "he_IL";
        } elseif ($this -> getUser() -> getCulture() == "hr") {
            $this -> user_culture = "hr_HR";
        } elseif ($this -> getUser() -> getCulture() == "hu") {
            $this -> user_culture = "hu_HU";
        } elseif ($this -> getUser() -> getCulture() == "it") {
            $this -> user_culture = "it_IT";
        } elseif ($this -> getUser() -> getCulture() == "ja") {
            $this -> user_culture = "ja_JP";
        } elseif ($this -> getUser() -> getCulture() == "ko") {
            $this -> user_culture = "ko_KR";
        } elseif ($this -> getUser() -> getCulture() == "lt") {
            $this -> user_culture = "lt_LT";
        } elseif ($this -> getUser() -> getCulture() == "lv") {
            $this -> user_culture = "lv_LV";
        } elseif ($this -> getUser() -> getCulture() == "nl") {
            $this -> user_culture = "nl_NL";
        } elseif ($this -> getUser() -> getCulture() == "no") {
            $this -> user_culture = "nb_NO";
        } elseif ($this -> getUser() -> getCulture() == "pl_PL") {
            $this -> user_culture = "pl_PL";
        } elseif ($this -> getUser() -> getCulture() == "pt") {
            $this -> user_culture = "pt_PT";
        } elseif ($this -> getUser() -> getCulture() == "ro") {
            $this -> user_culture = "ro_RO";
        } elseif ($this -> getUser() -> getCulture() == "ru") {
            $this -> user_culture = "ru_RU";
        } elseif ($this -> getUser() -> getCulture() == "sk") {
            $this -> user_culture = "sk_SK";
        } elseif ($this -> getUser() -> getCulture() == "sl") {
            $this -> user_culture = "sl_SI";
        } elseif ($this -> getUser() -> getCulture() == "sv") {
            $this -> user_culture = "sv_SE";
        } elseif ($this -> getUser() -> getCulture() == "tr") {
            $this -> user_culture = "tr_TR";
        } elseif ($this -> getUser() -> getCulture() == "zh") {
            $this -> user_culture = "zh_HK";
        }

        return $this -> user_culture;
    }

     public function siteURL()
    {
        $protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
        $domainName = $_SERVER['HTTP_HOST'];
        return $protocol.$domainName;
    }

}
